var bricks = window.bricks || {};

bricks.Popup = class extends bricks.VBox {
	/*
	{
		timeout:0
		archor:one of ['tl', 'tc', 'tr', 'cl', 'cc', 'cr', 'bl','bc', 'br']
		widget:null for bricks.Body, string value for widget's id or a widget object;
		auto_open:boolean
		auto_dismiss:boolean
		auto_destroy:boolean
		movable:boolean
		resizable:boolean
		modal:boolean
	*/
	constructor(opts){
		super(opts);
		this.no_opened = true;
		this.auto_task = null;
		this.issub = false;
		this.opened = false;
		this.set_css('popup');
		this.bring_to_top();
		this.moving_w = this;
		this.content_box = new bricks.VBox({width:'100%', height:'100%'});
		this.content_box.set_style('display', 'flex');
		this.content_box.set_style('overflow', 'auto');
		super.add_widget(this.content_box);
		if (this.auto_dismiss){
			bricks.Body.bind('click', this.click_outside.bind(this));
		}
		this.target_w = bricks.Body;
		this.moving_status = false;
		if (this.movable){
			this.setup_movable();
			// console.log('movable ...');
		}
		if (this.resizable){
			this.setup_resizable();
		}
		this.set_style('display', 'none');
		bricks.Body.add_widget(this);
		this.bind('click', this.bring_to_top.bind(this));
	}
	bring_to_top(){
		if (this == bricks.app.toppopup){
			return;
		}
		if (bricks.app.toppopup)
			bricks.app.toppopup.set_css('toppopup', true);
		this.zindex = bricks.app.new_zindex();
		this.set_style('zIndex', this.zindex);
		this.set_css('toppopup');
		bricks.app.toppopup = this;
	}

	setup_resizable(){
		this.resizable_w = new bricks.Icon({rate:1.5, url:bricks_resource('imgs/right-bottom-triangle.png')});
		super.add_widget(this.resizable_w);
		this.resizable_w.set_css('resizebox');
		this.resizable_w.bind('mousedown', this.resize_start_pos.bind(this));
		bricks.Body.bind('mousemove', this.resizing.bind(this));
		bricks.Body.bind('mouseup', this.stop_resizing.bind(this));
	}
	resize_start_pos(e){
		if (e.target != this.resizable_w.dom_element) 
		{
			// console.log('not event target');
			return;
		}
		var rect = this.showRectage();
		this.resize_status = true;
		this.s_offsetX = e.clientX;
		this.s_offsetY = e.clientY;
		this.s_width =  rect.width;
		this.s_height = rect.height;
		e.preventDefault();
		// console.log('resize_start_pos():', this.s_width, this.s_height, this.s_offsetX, this.s_offsetY);
	}
	resizing(e){
		if (e.target != this.resizable_w.dom_element){
			this.stop_resizing();
			// console.log('resizing(): not event target');
			return;
		}
		if (!this.resize_status){
			// console.log('resizing(): not in resize status');
			return;
		}
		var cx, cy;
		cx = this.s_width + e.clientX - this.s_offsetX;
		cy = this.s_height + e.clientY - this.s_offsetY;
		this.set_style('width', cx + 'px');
		this.set_style('height',  cy + 'px');
		// console.log('resizing():', this.resize_status, cx, cy);
		e.preventDefault();
	}
	positify_tl(){
		var rect, w, h, t, l;
		if (this.top && this.left){
			this.set_style('top', this.top);
			this.set_style('left', this.left);
			return;
		}
		rect = bricks.app.showRectage();
		if (this.cwidth && this.cwidth > 0){
			w = this.cwidth * bricks.app.charsize;
		} else if (this.width){
			if (this.width.endsWith('px')){
				w = parseFloat(this.width);
			} else {
				w = parseFloat(this.width) * rect.width / 100;
			}
		} else {
			w = rect.width * 0.8;
		}
		if (this.cheight && this.cheight > 0){
			h = this.cheight * bricks.app.charsize;
		} else if (this.height){
			if (this.height.endsWith('px')){
				h = parseFloat(this.height);
			} else {
				h = parseFloat(this.height) * rect.height / 100;
			}
		} else {
			h = rect.height * 0.8;
		}
		var archor = this.archor || 'cc';
		switch(archor[0]){
			case 't':
				t = 0;
				break;
			case 'c':
				t = (rect.height - h) / 2;
				break;
			case 'b':
				t = rect.height - h;
				break;
			default:
				t = (rect.height - h) / 2;
				break;
		}	
		switch(archor[1]){
			case 'l':
				l = 0;
				break;
			case 'c':
				l = (rect.width - w) / 2;
				break;
			case 'r':
				l = rect.width - w;
				break;
			default:
				l = (rect.width - w) / 2;
				break;
		}	
		this.set_style('top', t + 'px');
		this.set_style('left', l + 'px');
		return {
			top:t,
			left:l
		}
	}
			
	stop_resizing(e){
		this.resize_status = false;
		bricks.Body.unbind('mousemove', this.resizing.bind(this));
		bricks.Body.unbind('mouseup', this.stop_resizing.bind(this));
		// console.log('stop_resizing():', this.resize_status);
	}
	
	setup_movable(){
		this.moving_w.bind('mousedown', this.rec_start_pos.bind(this));
		this.moving_w.bind('touchstart', this.rec_start_pos.bind(this));
	}
	rec_start_pos(e){
		if (e.target != this.moving_w.dom_element) 
		{
			// console.log('moving star failed', e.target, this.moving_w.dom_element, 'difference  ...');
			return;
		}
		this.moving_status = true;
		var rect = this.showRectage();
		this.offsetX = e.clientX - rect.left;
		this.offsetY = e.clientY - rect.top;
		// console.log(rect, '========', this.offsetX, this.offsetY, e.clientX, e.clientY);
		
		bricks.Body.bind('mouseup', this.stop_moving.bind(this));
		bricks.Body.bind('touchend', this.stop_moving.bind(this));
		this.moving_w.bind('mousemove', this.moving.bind(this));
		this.moving_w.bind('touchmove', this.moving.bind(this));
		e.preventDefault();
		// console.log('moving started ...');
	}
	moving(e){
		if (e.target != this.moving_w.dom_element){
			// console.log('moving failed', e.target, this.moving_w.dom_element, 'difference  ...');
			this.stop_moving();
		}
		if (!this.moving_status){
			// console.log('moving failed', 'not started  ...');
			return;
		}
		var cx, cy;
		cx = e.clientX - this.offsetX;
		cy = e.clientY - this.offsetY;
		// console.log(cx, cy, e.clientX, e.clientY, this.offsetX, this.offsetY, '==========');
		this.set_style('left', cx + 'px');
		this.set_style('top',  cy + 'px');
		e.preventDefault();
	}
	stop_moving(e){
		// console.log('stop moving ....');
		this.moving_status = false;
		this.moving_w.unbind('mousemove', this.moving.bind(this));
		this.moving_w.unbind('touchmove', this.moving.bind(this));
		bricks.Body.unbind('mouseup', this.stop_moving.bind(this));
		bricks.Body.unbind('touchend', this.stop_moving.bind(this));
	}
	click_outside(event){
		if (event.target != this.dom_element){
			this.dismiss();
		}
	}
	add_widget(w, index){
		this.content_box.add_widget(w, index);
		if (this.auto_open){
			this.open();
		} else {
			// console.log('auto_open is ', this.auto_open, ' so not auto open it', this.opts, w);
		}
	}
	open(){
		var rect, w, h;
		if (this.opened) {
			return;
		}
		this.opened = true;
		if (this.no_opened){
			if (this.widget instanceof bricks.JsWidget){
				this.target_w = this.widget;
				this.issub = true;
			} else {
				var w = bricks.getWidgetById(this.widget, bricks.Body);
				if (w){
					this.issub = true
					this.target_w = w;
				} 
			}
			this.positify_tl()
		}
		this.no_opened = false;
		this.set_style('display', 'block');
		this.dispatch('opened');
		if (this.timeout > 0){
			this.auto_task = schedule_once(this.dismiss.bind(this), this.timeout)
		}
		if (this.opts.modal && this.opts.widget){
			this.target_w.disabled(true);
		}
		this.content_box.disabled(false);
	}
	dismiss(){
		if (this.opts.modal){
			this.target_w.disabled(false);
		}
		this.opened = false;
		if (this.auto_task){
			this.auto_task.cancel();
			this.auto_task = null;
		}
		this.set_style('display','none');
		this.dispatch('dismissed');
		if (this.auto_destroy){
			this.destroy();
			this.dispatch('destroy');
		}
	}
	destroy(){
		if (this.opened){
			this.dismiss();
		}
		if (this.parent){
			this.parent.remove_widget(this);
			this.parent = null;
		}
	}
}

bricks.PopupWindow = class extends bricks.Popup {
	/*
	{
		title:
		icon:
		params:
		url:
	}
	*/
	constructor(opts){
		opts.moviable = true;
		opts.resizable = true;
		opts.auto_open = true;
		opts.auto_dismiss = false;
		opts.auto_destroy = false;
		super(opts);
		this.title_bar = new bricks.HBox({cheight:1.5, width:'100%'});
		this.title_bar.set_css('titlebar')
		this.moving_w = this.title_bar;
		this.parent_add_widget(this.title_bar);
		this.build_title_bar();
		var filler = new bricks.Filler({});
		this.parent_add_widget(filler)
		this.content_w = new bricks.Layout({});
		this.content_w.set_css('flexbox');
		this.auto_open = true;
		filler.add_widget(this.content_w);
		// console.log(this.auto_open, 'opts=', opts);
	}
	async load_content(){
		var dic = {
			"widgettype":"urlwidget",
			"options":{
				"params":this.params,
				"url":this.url
			}
		}
		var w = bricks.widgetBuild(dic, bricks.Body);
		this.add_widget(w);
	}
	build_title_bar(){
		var icon = new bricks.Icon({
			rate:this.opts.rate,
			url:this.opts.icon || bricks_resource('imgs/app.png')
		});
		this.title_bar.add_widget(icon);
		this.tb_w = new bricks.IconBar( {
			cheight:1,
			margin:'5px',
			rate:0.8,
			tools:[
				{
					name:'delete',
					icon:bricks_resource('imgs/app_delete.png'),
					dynsize:true,
					tip:'Destroy this window'
				},
				{
					name:'minimax',
					icon:bricks_resource('imgs/app_minimax.png'),
					dynsize:true,
					tip:'minimax this window'
				},
				{
					name:'fullscreen',
					icon:bricks_resource('imgs/app_fullscreen.png'),
					dynsize:true,
					tip:'fullscreen this window'
				}
			]
		});
		this.title_bar.add_widget(this.tb_w);
		this.tb_w.bind('delete', this.destroy.bind(this));
		this.tb_w.bind('minimax', this.dismiss.bind(this));
		this.tb_w.bind('fullscreen', this.enter_fullscreen.bind(this));
		if (this.title){
			this.title_w = new bricks.Text({text:this.title});
			this.title_bar.add_widget(this.title_w);
		}
	}
	set_title(txt){
		if (this.title_w){
			this.title_w.set_text(txt);
		}
	}
	parent_add_widget(w, index){
		var ao = this.autho_open;
		this.auto_open = false;
		super.add_widget(w, index);
		this.auto_open = ao;
	}
	add_widget(w, index){
		// console.log('auto_open=', this.auto_open);
		this.content_w.add_widget(w, index);
		if (this.auto_open){
			this.open();
		} else {
			this.open();
			// console.log('auto_open is false, not auto open');
		}
	}
	open(){
		var f = bricks.app.docks.find(o => {
			if (o == this){
			}
		});
		if (! f){
			bricks.app.docks.push(this);
		}
		super.open();
	}
	dismiss(){
		var f = bricks.app.docks.find(o=> o===this);
		if (!f){
			bricks.app.docks.push(this);
		}
		super.dismiss()
	}
}
bricks.Dock = class extends bricks.HBox {
	constructor(opts){
		opts.cheight = opts.cheight || 2;
		opts.width = opts.width || "80%";
		super(opts);
		this.set_css('scroll');
		this.pw = [];
	}
	add_popupwindow(pw){
		var info = pw.get_window_info();
		
	}
	del_popupwindow(pw){
	}
}

bricks.Factory.register('Popup', bricks.Popup);
bricks.Factory.register('PopupWindow', bricks.PopupWindow);
